"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const EventEmitter_1 = require("../common/EventEmitter");
const CriteriaBuilder_1 = require("./activeRecords/common/CriteriaBuilder");
/**
 * Основной класс сущностей
 * */
class ResourceEntity extends EventEmitter_1.EventEmitter {
    constructor(factory) {
        super();
        this.required = [];
        this.factory = factory;
        this.criteriaBuilder = new CriteriaBuilder_1.CriteriaBuilder(this);
    }
    getFactory() {
        return this.factory;
    }
    /**
     * @returns присутствует ли сущность на портале AmoCRM
     * */
    isNew() {
        return this.id === undefined;
    }
    getEmbedded() {
        return this._embedded || {};
    }
    setEmbedded(patch) {
        const embedded = this.getEmbedded();
        this._embedded = Object.assign(Object.assign({}, embedded), patch);
    }
}
exports.default = ResourceEntity;
//# sourceMappingURL=ResourceEntity.js.map