import { IEmbedded, IEmbeddedEntity, IResourceEntity, IResourceEntityWithEmbedded, IResourceFactory } from "../../../interfaces/api";
import { ObjectKey } from "../../../interfaces/common";
import { ICriteriaItem } from "./CriteriaBuilder";
export interface IEmbeddedEntityList<E extends IEmbeddedEntity> extends ICriteriaItem {
    length: number;
    add(criteria: E[]): void;
    set(value: E[] | null): void;
    get(): E[];
    remove(value?: E[]): void;
}
export interface IQueryAttributes<E extends IEmbeddedEntity> {
    save?: ObjectKey<E>[];
    create?: ObjectKey<E>[];
    update?: ObjectKey<E>[];
}
export interface IEmbeddedEntityListOptions<T extends IResourceFactory<IResourceEntity<T>>, E extends IEmbeddedEntity> {
    entity: IResourceEntityWithEmbedded<T, E>;
    embeddedType: ObjectKey<IEmbedded<E>>;
    attributes?: IQueryAttributes<E>;
}
export declare class EmbeddedEntityList<T extends IResourceFactory<IResourceEntityWithEmbedded<T, E>>, E extends IEmbeddedEntity> implements IEmbeddedEntityList<E> {
    protected entity: IResourceEntityWithEmbedded<T, E>;
    protected embeddedType: ObjectKey<IEmbedded<E>>;
    protected attributes?: IQueryAttributes<E>;
    constructor(options: IEmbeddedEntityListOptions<T, E>);
    add(criteria: object[]): void;
    set(value: IEmbeddedEntity[] | null): void;
    get length(): number;
    get(): E[];
    remove(value?: IEmbeddedEntity[]): void;
    getEmbeddedSaveCriteria(attributes?: ObjectKey<E>[]): {
        _embedded?: undefined;
    } | {
        _embedded: {
            [x: string]: E[];
        };
    };
    getCreateCriteria(): {
        _embedded?: undefined;
    } | {
        _embedded: {
            [x: string]: E[];
        };
    };
    getUpdateCriteria(): {
        _embedded?: undefined;
    } | {
        _embedded: {
            [x: string]: E[];
        };
    };
}
