import { IResourceEntity, IResourceEntityWithEmbedded, IResourceFactory } from "../../../../interfaces/api";
import { TConstructor } from "../../../../types";
import { IEmbeddedCatalogElement } from "../../CatalogElement";
import { IHasSaveEntity } from "../hasSave";
import { IEmbeddedEntityList, IQueryAttributes } from "../../common/EmbeddedEntityList";
export interface IHasEmbeddedCatalogElementsEntity<T extends IResourceFactory<IResourceEntity<T>>> extends IResourceEntity<T> {
    embeddedCatalogElements: IEmbeddedEntityList<IEmbeddedCatalogElement>;
}
export interface IHasEmbeddedCatalogElementsOptions {
    attributes?: IQueryAttributes<IEmbeddedCatalogElement>;
}
export declare type IRequiredEntity<T extends IResourceFactory<IResourceEntity<T>>> = IHasSaveEntity<T> & IResourceEntityWithEmbedded<T, IEmbeddedCatalogElement>;
export declare function hasEmbeddedCatalogElements(options?: IHasEmbeddedCatalogElementsOptions): <T extends IResourceFactory<IRequiredEntity<T>>>(Base: TConstructor<IRequiredEntity<T>>) => TConstructor<IResourceEntity<T>>;
