import { IResourceEntity, IResourceEntityWithEmbedded, IResourceFactory } from "../../../../interfaces/api";
import { TConstructor } from "../../../../types";
import { IEmbeddedCustomer } from "../../Customer";
import { IHasSaveEntity } from "../hasSave";
import { IEmbeddedEntityList, IQueryAttributes } from "../../common/EmbeddedEntityList";
export interface IHasEmbeddedCustomersEntity<T extends IResourceFactory<IResourceEntity<T>>> extends IResourceEntity<T> {
    customerList: IEmbeddedEntityList<IEmbeddedCustomer>;
}
export interface IHasEmbeddedCustomersOptions {
    attributes?: IQueryAttributes<IEmbeddedCustomer>;
}
export declare type IRequiredEntity<T extends IResourceFactory<IResourceEntity<T>>> = IHasSaveEntity<T> & IResourceEntityWithEmbedded<T, IEmbeddedCustomer>;
export declare function hasEmbeddedCustomers(options?: IHasEmbeddedCustomersOptions): <T extends IResourceFactory<IRequiredEntity<T>>>(Base: TConstructor<IRequiredEntity<T>>) => TConstructor<IResourceEntity<T>>;
