import { IResourceEntity, IResourceEntityWithEmbedded, IResourceFactory } from "../../../../interfaces/api";
import { TConstructor } from "../../../../types";
import { IHasSaveEntity } from "../hasSave";
import { IEmbeddedEntityList, IQueryAttributes } from "../../common/EmbeddedEntityList";
import { IEmbeddedLossReason } from "../../LossReason";
export interface IHasEmbeddedLossReasonsEntity<T extends IResourceFactory<IResourceEntity<T>>> extends IResourceEntity<T> {
    lossReasons: IEmbeddedEntityList<IEmbeddedLossReason>;
}
export interface IHasEmbeddedLossReasonsOptions {
    attributes?: IQueryAttributes<IEmbeddedLossReason>;
}
export declare type IRequiredEntity<T extends IResourceFactory<IResourceEntity<T>>> = IHasSaveEntity<T> & IResourceEntityWithEmbedded<T, IEmbeddedLossReason>;
export declare function hasEmbeddedLossReasons(options?: IHasEmbeddedLossReasonsOptions): <T extends IResourceFactory<IRequiredEntity<T>>>(Base: TConstructor<IRequiredEntity<T>>) => TConstructor<IResourceEntity<T>>;
