import { ILeadFactory } from "./LeadFactory";
import { IContactFactory } from "./ContactFactory";
import { ICompanyFactory } from "./CompanyFactory";
import { ITagFactory } from "./TagFactory";
import { ICustomerFactory } from "./CustomerFactory";
import { TConstructor } from "../../types";
export interface IFactoryConstructors {
    leads: TConstructor<ILeadFactory>;
    contacts: TConstructor<IContactFactory>;
    companies: TConstructor<ICompanyFactory>;
    tags: TConstructor<ITagFactory>;
    customers: TConstructor<ICustomerFactory>;
}
declare const factories: IFactoryConstructors;
export default factories;
