"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasCreate = void 0;
const tslib_1 = require("tslib");
function hasCreate(Base) {
    return class CanCreate extends Base {
        create(criteria, options) {
            return tslib_1.__awaiter(this, void 0, void 0, function* () {
                const url = this.getUrl();
                const requestCriteria = this.getEntityCriteria(criteria);
                const request = this.getRequest();
                const { data } = yield request.post(url, requestCriteria, options);
                const response = this.getEmbedded(data);
                this.emit('create');
                return response.map(attributes => this.from(attributes));
            });
        }
    };
}
exports.hasCreate = hasCreate;
//# sourceMappingURL=hasCreate.js.map