import { IRequestOptions } from "../../../interfaces/common";
import { IResourceEntity, IResourceFactory } from "../../../interfaces/api";
import { IResourcePagination } from "../../ResourcePagination";
import { TFactoryConstructor } from "../../../types";
export interface IGetCriteria {
    with?: string;
    page?: number;
    limit?: number;
    query?: string | number;
    order?: string;
}
export interface IHasGetFactory<T> {
    get(criteria?: IGetCriteria, options?: IRequestOptions): Promise<IResourcePagination<T>>;
}
export declare function hasGetByCriteria<T extends IResourceEntity<IResourceFactory<T>>>(Base: TFactoryConstructor<T>): TFactoryConstructor<T>;
