"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasUpdatableTags = void 0;
function hasUpdatableTags(constructor) {
    return class HasUpdatableTags extends constructor {
        get tagList() {
            if (this._tagList) {
                return this._tagList;
            }
            const tagList = {
                update: this.updateTags.bind(this),
                clear: this.clearTags.bind(this)
            };
            this._tagList = tagList;
            return tagList;
        }
        updateTags(criteria, options) {
            const factory = this.getFactory();
            return factory.setTagsFor([this], criteria, options);
        }
        clearTags(options) {
            const factory = this.getFactory();
            return factory.clearTagsFor([this], options);
        }
    };
}
exports.hasUpdatableTags = hasUpdatableTags;
//# sourceMappingURL=hasUpdatableTags.js.map